<?php

namespace Bixo\Chat\Http\Controllers;

use App\Http\Controllers\ActionController as BaseController;
use Exception;
use Bixo\Chat\Actions\ChatReport;
use Bixo\Chat\Http\Requests\ChatReportRequest;

/**
 * Admin web controller class.
 */
class ChatReportController extends BaseController
{
    /**
     * Action controller function for chat.
     *
     * @param Model $model
     * @param action next action for the model.
     *
     * @return Response
     */
    public function __invoke(ChatReportRequest $request, $report)
    {
        try {
        
            $this->model = app(Chat::class);
            $data = ChatReport::run($request, $report);

            return $this->response->message(trans('messages.success.updated', ['Module' => trans('chat::chat.name')]))
                ->code(204)
                ->data(compact('data'))
                ->status('success')
                ->url(guard_url('chat/chat/' . $report))
                ->redirect();
        } catch (Exception $e) {
            return $this->response->message($e->getMessage())
                ->code(400)
                ->status('error')
                ->url(guard_url('chat/chat/' . $report))
                ->redirect();
        }
    }
}
