<?php

namespace Bixo\Chat\Policies;

use Bixo\Chat\Models\Chat;
use Illuminate\Foundation\Auth\User as Authenticatable;

trait ChatAction
{

    /**
     * Determine if the given user can copy the given chat.
     *
     * @param Authenticatable $user
     *
     * @return bool
     */
    public function copy(Authenticatable $user, Chat $chat)
    {

        if ($authUser->canDo('chat.chat.action.copy')) {
            return true;
        }

        $this->model->is_owner;
    }

    /**
     * Determine if the given user can empty the given chat.
     *
     * @param Authenticatable $user
     *
     * @return bool
     */
    function empty(Authenticatable $user, Chat $chat) {

        if ($authUser->canDo('chat.chat.action.empty')) {
            return true;
        }

        $this->model->is_owner;
    }

    /**
     * Determine if the given user can transfer the given chat.
     *
     * @param Authenticatable $user
     *
     * @return bool
     */
    public function transfer(Authenticatable $user, Chat $chat)
    {

        if ($authUser->canDo('chat.chat.action.transfer')) {
            return true;
        }

        $this->model->is_owner;
    }

}
