<?php

namespace Bixo\Chat\Providers;

use Illuminate\Foundation\Support\Providers\EventServiceProvider as ServiceProvider;
use Bixo\Chat\Events\ChatAction;
use Bixo\Chat\Events\ChatWorkflow;
use Bixo\Chat\Listeners\ChatAction as ChatActionListener;
use Bixo\Chat\Listeners\ChatWorkflow as ChatWorkflowListener;


class EventServiceProvider extends ServiceProvider
{
    /**
     * The event listener mappings for the application.
     *
     * @var array
     */
    protected $listen = [
    
        ChatAction::class => [
            ChatActionListener::class,
        ],
        ChatWorkflow::class => [
            ChatWorkflowListener::class,
        ],
    ];

    /**
     * Register any other events for your application.
     *
     * @param \Illuminate\Contracts\Events\Dispatcher $events
     *
     * @return void
     */
    public function boot()
    {
        parent::boot();

        //
    }
}
